#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: cafeteria1.py 582 2014-04-19 19:19:24Z pieper $

class Cafeteria:
    def __init__(self):
        self.derTresen= Tresen()
        self.name= "Futterkrippe"
        self.geschlossen= True
        self.ausgabeZeiten= "Pausen"
        self.dieVerkaeuferin= Verkaeuferin("Frau Müller")

    def oeffnen(self):
        self.geschlossen = False
        print("geschlossen?", str(self.geschlossen))
        self.derTresen.broetchenPraesentieren()

    def schliessen(self):
        self.geschlossen = True
        print("geschlossen?", str(self.geschlossen))

class Broetchen:
    def __init__(self, derBelag, derPreis):
        self.setzeBelag(derBelag)
        self.setzePreis(derPreis)
        print("Brötchen mit",self.gibBelag(),"zu",self.gibPreis(),"€ erstellt")

    def gibBelag(self):
        return self.belag

    def setzeBelag(self, neuerBelag):
        self.belag= neuerBelag

    def gibPreis(self):
        return self.preis

    def setzePreis(self, neuerPreis):
        self.preis= neuerPreis

class Schueler:
    def __init__(self, derName, eigenesGeld):
        self.setzeName(derName)
        self.setzeGeld(eigenesGeld)        
        self.setzeHunger(True)
        self.setzeOrt(None)

    def setzeOrt(self, oertlichkeit):
        self.ort= oertlichkeit

    def gibOrt(self):
        return self.ort

    def setzeHunger(self, derHunger):
        self.hunger= derHunger

    def setzeName(self, einName):
        self.name= einName
        
    def setzeGeld(self, dasGeld):
        self.geld=  dasGeld   

    def produktAuswaehlen(self, dieAuswahl):
        self.belagAuswahl= dieAuswahl

    def produktKaufen(self):
        self.auswahl= self.ort.derTresen.gibBroetchen(self.belagAuswahl)
        self.produktPreis= self.auswahl.gibPreis()       
        if self.produktPreis <= self.geld:
            self.ort.derTresen.broetchenEntfernen(self.belagAuswahl)
            self.bezahlenGehen()
        else:
            self.auswahl = None

    def bezahlenGehen(self):
        print(self.name,"vorher Geld:",str(self.geld),"€")
        self.produktPreis= self.ort.dieVerkaeuferin.preisNennen(self.auswahl)
        print(self.belagAuswahl+"brötchen", self.produktPreis,"€")
        self.auswahl= None
        self.ort.dieVerkaeuferin.geldAnnehmen(self.produktPreis)
        self.geld= self.geld - self.produktPreis
        self.auswahl= self.ort.dieVerkaeuferin.broetchenGeben()
        print (self.name,"nachher Geld:", str(round(self.geld*100)/100.0),"€")

class Verkaeuferin:
    def __init__(self, einName):
        self.setzeName(einName)
        self.setzeBeruf("Verkäuferin")
        self.setzeGeldInKasse(0.0)

    def setzeGeldInKasse(self, geld):
        self.geldInKasse= geld

    def setzeName(self, derName):
        self.name=derName
    
    def setzeBeruf(self, derBeruf):
        self.beruf= derBeruf

    def geldAnnehmen(self,einnahme):
        self.geldInKasse= self.geldInKasse + einnahme

    def preisNennen(self, dasProdukt):
        self.produkt= dasProdukt
        return self.produkt.gibPreis()

    def broetchenGeben(self):
        return self.produkt

class Tresen:
    def broetchenPraesentieren(self):
        self.salamiBroetchen= Broetchen("Salami", 1.5)
        self.kaeseBroetchen= Broetchen("Käse", 1.5)
        self.schnitzelBroetchen= Broetchen("Schnitzel", 2.0)

    def gibBroetchen(self, derBelag):
        if derBelag == "Schnitzel":
            return self.schnitzelBroetchen
        elif derBelag == "Salami":
            return self.salamiBroetchen
        else:
            return self.kaeseBroetchen

    def broetchenEntfernen(self,derBelag):
        if derBelag == "Schnitzel":
            self.schnitzelBroetchen= None
        elif derBelag == "Salami":
            self.salamiBroetchen= None
        else:
            self.kaeseBroetchen= None

if __name__ == "__main__":
    print ("Testroutinen: ")
    lisa= Schueler("Lisa", 2.30)
    tim= Schueler("Tim", 1.60)

    cafete= Cafeteria()
    cafete.oeffnen()

    lisa.setzeOrt(cafete)
    tim.setzeOrt(cafete)

    lisa.produktAuswaehlen("Schnitzel")
    tim.produktAuswaehlen("Käse")
    lisa.produktKaufen()
    tim.produktKaufen()

    cafete.schliessen()
    
