#
# (C)opyright  L. Humbert -- September 2010
# Informatik GK 11. Jahrgang
#
# 
debug= True

class Mobiltelefon:
    def __init__(self,ablage,bezeichnung):
        self.name= bezeichnung
        if debug:
            print ("Mobiltelefon:", self.gibName(),"wird erzeugt")
        self.hatTelefonspeicher= Verzeichnis(ablage,"c:")
        
    def gibTelefonspeicher(self):
        return self.hatTelefonspeicher  

    def gibName(self):
        return self.name    
        
    def empfangePerBluetooth(self,datei):
        if debug: print ("Datei",datei.gibName(),"per Bluetooth empfangen")
        self.hatTelefonspeicher.inVerzeichnis(datei)


class Datei:
    def __init__(self,name):
        self.dateiname= name 
        if debug:
            print ("Datei:", self.gibName(),"erzeugt")
        
    def loeschen(self):
        self.dateiname=None
        self=None
        
    def gibName(self):
        return self.dateiname    

    def sendePerBluetooth(self,anMobiltelefon):
        anMobiltelefon.empfangePerBluetooth(self)


class Verzeichnis:
    def __init__(self,ablage, name):
        self.verzeichnisname= name
        self.zwischenablage= ablage
        self.elemente= list()  # sowohl Unterverzeichnisse als auch Dateien
        if debug:
            print ("Verzeichnis:", self.gibName(),"erzeugt")

    def _elemente_ausgeben_(self):
        if debug: 
            print ("Verzeichnis:", self.gibName(),)
            if self.elemente == None or self.elemente.__len__() == 0:
                print ("ist leer")
                return
        for elem in self.elemente:
            print  ("Name:", elem.gibName())

    def _elemente_rekursiv_ausgeben_(self):
        if debug: 
            print ("Verzeichnis:", self.gibName(),)
            if self.elemente == None or self.elemente.__len__() == 0:
                print ("ist leer")
                return
        for elem in self.elemente:
            print ("Name:", elem.gibName())
            if str(elem.__class__).find("Verzeichnis") > 0:
                elem._elemente_rekursiv_ausgeben_()
    
    def gibName(self):
        return self.verzeichnisname

    def erstelleVerzeichnis(self,ablage,bezeichnung):
        unterverzeichnis= Verzeichnis(ablage,bezeichnung)
        self.elemente.append(unterverzeichnis)
        self._elemente_ausgeben_()
        return unterverzeichnis      

    def inVerzeichnis(self,dateiOderVerzeichnis):
        self.elemente.append(dateiOderVerzeichnis)
        self._elemente_ausgeben_()

    def einfuegen(self):
        self.elemente.append(self.zwischenablage.gibVerweis())

    def ausschneiden(self,objektverweis):
        self.zwischenablage.setzeVerweis(objektverweis)
        self.freigeben(objektverweis)
        
    def freigeben(self,objektverweis):
        self.elemente.remove(objektverweis)
        self._elemente_ausgeben_()

    def loeschen(self):
        if debug: print ("loeschen:",self.gibName())
        if self.elemente.__len__() == 0:
            self.elemente= None
            if debug: print ("geloescht")
            self.verzeichnisname= None
            self= None
            return
        else:
            for elem in self.elemente: 
                if debug: print (elem.gibName(),)
                if str(elem.__class__).find("Datei") > 0 or elem.elemente.__len__() == 0:
                    self.elemente.remove(elem)                    
                else:
                    elem.loeschen()
        self.elemente=None
 
        
class Zwischenablage:
    def __init__(self):
        self.kenntObjekt = None

    def setzeVerweis(self,verweisAufObjekt):
        self.kenntObjekt= verweisAufObjekt
      
    def gibVerweis(self):
        verweis= self.kenntObjekt
        #self.kenntObjekt= None # kann ggf. entfallen
        return verweis

      
class Papierkorb:
    def __init__(self):
        self.kenntObjekte= list()

    def einfuegen(self,verweis):
        self.kenntObjekt.append(verweis)
      
    def loeschen(self):
        for elem in self.kenntObjekte:
            elem.loeschen()
            self.kenntObjekte.remove(elem)

if __name__ == "__main__":
     ablage= Zwischenablage()

     annesMobiltelefon= Mobiltelefon(ablage,"Annes Mobiltelefon")

     # ... legt Anne  das Verzeichnis
     #   e:/Archiv/2010/
     # an.
     speicherkarteVerzeichnis= Verzeichnis(ablage,"e:")
     archiv= speicherkarteVerzeichnis.erstelleVerzeichnis(ablage,"Archiv")
     a2010= archiv.erstelleVerzeichnis(ablage,"2010")

     # Erstellen der Verzeichnisstruktur und Anlegen der Dateien lt. Pfadangaben ...
     telefonspeicherAnneVerzeichnis= annesMobiltelefon.gibTelefonspeicher()

     data= telefonspeicherAnneVerzeichnis.erstelleVerzeichnis(ablage,"Data")

     images= data.erstelleVerzeichnis(ablage,"Images")

     screenshots= images.erstelleVerzeichnis(ablage,"Screenshots")
     scrn= Datei("scrn43.png")
     screenshots.inVerzeichnis(scrn)

     pictures= images.erstelleVerzeichnis(ablage,"Pictures")
     foto= Datei("Foto-234.jpg")
     pictures.inVerzeichnis(foto)

     videos= data.erstelleVerzeichnis(ablage,"Videos")
     baum=  Datei("Baum1.mp4")
     videos.inVerzeichnis(baum)

     sounds= data.erstelleVerzeichnis(ablage,"Sounds")
     digital= sounds.erstelleVerzeichnis(ablage,"Digital")
     blackbird= Datei("Blackbird.aac")
     digital.inVerzeichnis(blackbird)

     documents= data.erstelleVerzeichnis(ablage,"Documents")
     presentation= Datei("praesentation-INFOS.pdf")
     documents.inVerzeichnis(presentation)

     telefonspeicherAnneVerzeichnis._elemente_rekursiv_ausgeben_()

     # 
     annesFreundinMobiltelefon= Mobiltelefon(ablage,"Mobiltelefon -- Freundin Anne")

     #  Anne verschiebt die Dateien ... 
     #  in das neu angelegte Verzeichnis.
     screenshots.ausschneiden(scrn)
     a2010.inVerzeichnis(ablage.gibVerweis())

     videos.ausschneiden(baum)
     a2010.inVerzeichnis(ablage.gibVerweis())

     # Die Bilddatei ...
     pictures.freigeben(foto)
     foto.loeschen()
     # und den Klingelton ...
     digital.freigeben(blackbird)
     blackbird.loeschen()
     # loescht sie.

     # Die Praesentation ... sendet sie per Bluetooth an das Mobiltelefon ihrer Freundin.
     presentation.sendePerBluetooth(annesFreundinMobiltelefon)
     # (implizit: und gibt den Speicherplatz anschliessend frei)
     documents.freigeben(presentation)

     # Verzeichnisse loeschen -- ist noch nicht korrekt!
     telefonspeicherAnneVerzeichnis.loeschen()
     telefonspeicherAnneVerzeichnis._elemente_rekursiv_ausgeben_()

     documents._elemente_rekursiv_ausgeben_()
     # muss nun leer sein

     freundinTelefonspeicher= annesFreundinMobiltelefon.gibTelefonspeicher()
     freundinTelefonspeicher._elemente_rekursiv_ausgeben_()
     # sollte die Datei presentation enthalten

