#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: musikcenterSet3.py 582 2014-04-19 19:19:24Z pieper $

# Umsetzung in Python - bisher ohne Klassenbeziehungen

## from sets import Set 
Set= set # in Python3 ist die Klasse set eingebaut 

# Kontrolle/Test:
# Auftrag 
# gibLieblingsliederAus
class Hoerer:
    def __init__(self,derName):
        self.name=derName
        self.stuecke=Set()
        print ("Objekt der Klasse Hoerer erstellt: ",derName)

    def fuegeStueckHinzu(self,stueck):
        self.stuecke.add(stueck)

    def entferneStueck(self,stueck):
        if stueck in self.stuecke:
            self.stuecke.remove(stueck)

    def gibLieblingslieder(self):
        return self.stuecke
        
    def gibLieblingsliederAus(self):
        print (self.name,[(lied.gibKuenstlerin(),lied.gibName()) for lied in self.gibLieblingslieder()])
        


class Musikstueck:
    def __init__(self,derName,dieKuenstlerIn):
        self.name=derName
        self.kuenstlerin=dieKuenstlerIn        
        print ("Objekt der Klasse Musikstueck erstellt:",derName,"-- Gruppe:",dieKuenstlerIn)

    def gibKuenstlerin(self):
        return self.kuenstlerin

    def gibName(self):
        return self.name            


class Gruppe:
    def __init__(self,derName):
        self.name=derName
        self.hoerer=Set()
        print ("Objekt der Klasse Gruppe erstellt:", derName)
    
    def fuegeHoererHinzu(self,neuerHoerer):
        self.hoerer.add(neuerHoerer)

    def entferneHoerer(self,hoerer):
        if hoerer in self.hoerer:
            self.hoerer.remove(hoerer)
            
    def erstellePlaylist(self):
        print ("erstellePlaylist")
        self.playlist=Playlist() # Aggregation (Objekt der Klasse Gruppe _hat_ ...)
        
    def erstelleGemeinsameLieblingslieder(self,menge1,menge2):
        self.erstellePlaylist()
        #
        # Mengenschnitt bilden
        self.playlist.setzeMenge(menge1.intersection(menge2))    
        return self.playlist.gibAbspielmenge()
        

class Playlist:
    def __init__(self):
        self.menge=Set()
        print ("Objekt der Klasse Playlist erstellt")

    def fuegeStueckHinzug(self,stueck):
        self.menge.add(stueck)

    def entferneStueck(self,stueck):    
        if stueck in self.menge:
            self.menge.remove(stueck)

    def setzeMenge(self, neueMenge):
        self.menge=neueMenge
    
    def abspielen(self):
        print ("Abspielen der Stuecke des Objekts der Playlist:")#, self.menge)
        print ([(lied.gibKuenstlerin(),lied.gibName()) for lied in self.menge])
        
    def gibAbspielmenge(self):
        return self.menge   


#>>> from musikcenter import Hoerer, Musikstueck, Gruppe, Playlist
#>>> dir()
#['Gruppe', 'Hoerer', 'Musikstueck', 'Playlist', '__builtins__', '__doc__', '__file__', '__name__', 'help', 'readline', 'rlcompleter', 'stuecke']

# Erzeugen der Objekte:
#
gruppeSpieleabend=Gruppe("Gruppe Spieleabend")

david=Hoerer("David")
klaus=Hoerer("Klaus")
lisa=Hoerer("Lisa")

gutenTag=Musikstueck("Guten Tag","Wir sind Helden")
losingMyReligion=Musikstueck("Losing my Religion","REM")
parallelUniverse=Musikstueck("Parallel Universum","Red Hot Chili Peppers")
radioBrennt=Musikstueck("Radio brennt","Die Ärzte")
bonnieUndClyde=Musikstueck("Bonnie und Clyde","Die toten Hosen")


